{--------------------------------------------------------}
{                    mdulo de variveis
{--------------------------------------------------------}

unit brvars;
interface

const
    versao = '4.0';
    beta = false;

    SALTOPAG = #$0c;

    MAIUSCULAS: set of char = ['A'..'Z', #$c0..#$df];   { ANSI apenas }
    MINUSCULAS: set of char = ['a'..'z', #$e0..#$ff];

    VOGAIS     = ['A', 'E', 'I', 'O', 'U', 'a', 'e', 'i', 'o', 'u',
                  {aeiou agudos}
                  '', '', '', '', '', '', '', '', '', '',
                  {aeo circunflexos}
                  '','','','','','',
                  {ao til}
                  '','','','',
                  {a grave}
                  '',''];

    CONSOANTES = ['B', 'C', 'D', 'F', 'G', 'H', 'J', 'L', 'M',
                  'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'X', 'Z',
                  'b', 'c', 'd', 'f', 'g',{'h',}'j', 'l', 'm',
                  'n', 'p', 'q', 'r', 's', 't', 'v', 'x', 'z',
                  '', '' ]; {cedilha}

    MAIUSCBRL     = ']';
    MAIUSCBRLU    = '{';
    MAIUSCINGLES  = '&';
    MAIUSCINGLESU = '\';
    GRIFOBRL      = '_';
    TRAVESSAOU    = '--';
    GRIFOBRU      = '_';
    GRIFOINGLES   = ']';
    ASPASVARIADASU = '$"';
    RETICENCIASU = '...';

    ABREASPASBRL  = '{';
    ABREASPASBRLU = '"';
    ABREASPASINU  = '"';
    FECHAASPASINU = '}';
    FECHAASPASBRL = '}';
    PONTOBRL      = '.';
    PONTOINU      = '/';
    RETICBRL      = '''''''';
    VIRGDECBRL    = ',';
    PONTODECBRL   = '''';

    PERCENTBRL    = '_}';
    PERCENROMILBRU = '_}}';
    PARAGRAFO     = 'ss';
    SINALNUMERO   = '#';

    BOLABRU       = 'o';
    ASPASANGBRU   = '\"';
    BARRABRU      = '\,';
    EUROBRU       = 'e';

    ABREPARENTU   = '(.';
    FECHAPARENTU  = '\)';
    ABRECOLCHU    = '[.';
    FECHACOLCHU   = '\]';

    RAIZU         = '~' + '.';
    UMQUARTOU     = '#,d';
    UMMEIOU       = '#,b';
    TRESQUARTOSU  = '#:d';
    BETAU         = 'b';

    ELEV_2_U      = '#b';
    ELEV_3_U      = '#c';
    ELEV_1_U      = '#a';

var
    arq: file;
    bufArq: array [0..1023] of char;
    pbufArq, lidosBuf: integer;
    fimDoArq: boolean;
    linhasDivididas: boolean;

    nomeArq, nomeSai: string;
    texto, textoCnv: string;

    emTinta: boolean;      { impresso braille em Tinta }
    maxcarac: integer;     { mximo de caracteres por liha }
    maxlin: integer;       { mximo de linhas na pgina }
    tipoCabec: integer;    { 0 = sem, 1 = frente, 2 = dois lados }
    autoFormata: boolean;  { auto formata juntando linhas }
    frenteVerso: boolean;  { impresso s de um lado do papel }
    veioDoEdit: boolean;   { texto codificado em PC-850 }
    afastaCabecPar: boolean;          { afasta cabecalhos pares }
    tiraBrancasInicioPag: boolean;    { remove linhas brancas no inicio da pagina }
    separaSilabas: boolean;           { separa silabas no fim da linha }

    titulo: shortstring;     { ttulo a imprimir }
    comTitulo: boolean;      { deve colocar ttulos e nmeros }
    numeraOrig: boolean;     { adiciona no ttulo nmero da pgina no original }
    numInic: integer;        { nmero a imprimir na primeira pgina }

    npag: integer;           { numero da pagina atual }
    nlin: integer;           { numero da linha atual }
    paginic: integer;        { primeira pgina a imprimir }
    pagfinal: integer;       { ltima pgina a imprimir }
    ncopias: integer;        { nmero de cpias desejado }

    centrando: boolean;      { est centrando agora }
    abre_aspas: boolean;     { abriu aspas }
    abre_aspas_inu: boolean; { abriu aspas: braille unificado }
    abriuParentLiterario: boolean;
                             { abriu parnteses literrio }

    sobraAnterior: string;   { trecho que sobrou da ltima sada }
    pagOrig: integer;        { pagina do original }

    margem: integer;         { margem  esquerda }
    margemSoImpar: boolean;  { faz margem s nas paginas impares }
    textoIngles: boolean;    { usa alternativas de maisculas e sublinhado }
    cabecIngles: boolean;    { idem no cabecalho }
    linhaNoRascunho: integer;  { equivalencia original-rascunho }

    tempoLinha: integer;       { tempo fixado para impresso de uma linha }
    paginando: boolean;        { faz paginao }
    usaBrailleAntigo: boolean; { usa braille anterior a 2002 }

    tabPrinter: array [#0..#255] of byte;

    nomeAmBCode: string;     { arquivo de codificao do braille antigo }
    nomeAmbCode2: string;    { arquivo de codificao do braille novo }

    adev, adriv, aport: array [0..255] of char;
    adevMode: cardinal;                  { configuraes da impressora PRN }

implementation
end.